Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_fragmentation.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include <cstring>
 
 #include "atom.hpp"
@@ -16,4 +18,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -41,5 +44,5 @@
   }
   FragmentCount = NoNonHydrogen*(1 << (c*order));
-  Log() << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl);
   return FragmentCount;
 };
@@ -65,9 +68,9 @@
     } // else it's "-1" or else and thus must not be added
   }
-  Log() << Verbose(1) << "The scanned KeySet is ";
+  DoLog(1) && (Log() << Verbose(1) << "The scanned KeySet is ");
   for(KeySet::iterator runner = CurrentSet.begin(); runner != CurrentSet.end(); runner++) {
-    Log() << Verbose(0) << (*runner) << "\t";
-  }
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*runner) << "\t");
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
   return (status != 0);
 };
@@ -97,5 +100,5 @@
 
   // 1st pass: open file and read
-  Log() << Verbose(1) << "Parsing the KeySet file ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Parsing the KeySet file ... " << endl);
   sprintf(filename, "%s/%s%s", path, FRAGMENTPREFIX, KEYSETFILE);
   InputFile.open(filename);
@@ -110,5 +113,6 @@
         testGraphInsert = FragmentList->insert(GraphPair (CurrentSet,pair<int,double>(NumberOfFragments++,1)));  // store fragment number and current factor
         if (!testGraphInsert.second) {
-          eLog() << Verbose(0) << "KeySet file must be corrupt as there are two equal key sets therein!" << endl;
+          DoeLog(0) && (eLog()<< Verbose(0) << "KeySet file must be corrupt as there are two equal key sets therein!" << endl);
+          performCriticalExit();
         }
       }
@@ -118,7 +122,7 @@
     InputFile.clear();
     Free(&buffer);
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "File " << filename << " not found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "File " << filename << " not found." << endl);
     status = false;
   }
@@ -150,5 +154,5 @@
 
   // 2nd pass: open TEFactors file and read
-  Log() << Verbose(1) << "Parsing the TEFactors file ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Parsing the TEFactors file ... " << endl);
   sprintf(filename, "%s/%s%s", path, FRAGMENTPREFIX, TEFACTORSFILE);
   InputFile.open(filename);
@@ -160,5 +164,5 @@
         InputFile >> TEFactor;
         (*runner).second.second = TEFactor;
-        Log() << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl);
       } else {
         status = false;
@@ -168,7 +172,7 @@
     // 4. Free and done
     InputFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "File " << filename << " not found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "File " << filename << " not found." << endl);
     status = false;
   }
@@ -198,5 +202,5 @@
   line += KEYSETFILE;
   output.open(line.c_str(), ios::out);
-  Log() << Verbose(1) << "Saving key sets of the total graph ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving key sets of the total graph ... ");
   if(output != NULL) {
     for(Graph::iterator runner = KeySetList.begin(); runner != KeySetList.end(); runner++) {
@@ -208,7 +212,8 @@
       output << endl;
     }
-    Log() << Verbose(0) << "done." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   } else {
-    eLog() << Verbose(0) << "Unable to open " << line << " for writing keysets!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open " << line << " for writing keysets!" << endl);
+    performCriticalExit();
     status = false;
   }
@@ -238,11 +243,11 @@
   line += TEFACTORSFILE;
   output.open(line.c_str(), ios::out);
-  Log() << Verbose(1) << "Saving TEFactors of the total graph ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving TEFactors of the total graph ... ");
   if(output != NULL) {
     for(Graph::iterator runner = KeySetList.begin(); runner != KeySetList.end(); runner++)
       output << (*runner).second.second << endl;
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "failed to open " << line << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open " << line << "." << endl);
     status = false;
   }
@@ -288,13 +293,13 @@
         (*PresentItem).second.first = fabs(Value);
         (*PresentItem).second.second = FragOrder;
-        Log() << Verbose(2) << "Updated element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Updated element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl);
       } else {
-        Log() << Verbose(2) << "Did not update element " <<  (*PresentItem).first << " as " << FragOrder << " is less than or equal to " << (*PresentItem).second.second << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Did not update element " <<  (*PresentItem).first << " as " << FragOrder << " is less than or equal to " << (*PresentItem).second.second << "." << endl);
       }
     } else {
-      Log() << Verbose(2) << "Inserted element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Inserted element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl);
     }
   } else {
-    Log() << Verbose(1) << "No Fragment under No. " << No << "found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "No Fragment under No. " << No << "found." << endl);
   }
 };
@@ -355,5 +360,5 @@
   atom *Walker = mol->start;
   map<double, pair<int,int> > *FinalRootCandidates = new map<double, pair<int,int> > ;
-  Log() << Verbose(1) << "Root candidate list is: " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Root candidate list is: " << endl);
   for(map<int, pair<double,int> >::iterator runner = AdaptiveCriteriaList->begin(); runner != AdaptiveCriteriaList->end(); runner++) {
     Walker = mol->FindAtom((*runner).first);
@@ -361,11 +366,12 @@
       //if ((*runner).second.second >= Walker->AdaptiveOrder) { // only insert if this is an "active" root site for the current order
       if (!Walker->MaxOrder) {
-        Log() << Verbose(2) << "(" << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "])" << endl;
+        DoLog(2) && (Log() << Verbose(2) << "(" << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "])" << endl);
         FinalRootCandidates->insert( make_pair( (*runner).second.first, pair<int,int>((*runner).first, (*runner).second.second) ) );
       } else {
-        Log() << Verbose(2) << "Excluding (" << *Walker << ", " << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "]), as it has reached its maximum order." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Excluding (" << *Walker << ", " << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "]), as it has reached its maximum order." << endl);
       }
     } else {
-      eLog() << Verbose(0) << "Atom No. " << (*runner).second.first << " was not found in this molecule." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Atom No. " << (*runner).second.first << " was not found in this molecule." << endl);
+      performCriticalExit();
     }
   }
@@ -391,5 +397,5 @@
     Walker = mol->FindAtom(No);
     //if (Walker->AdaptiveOrder < MinimumRingSize[Walker->nr]) {
-      Log() << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl);
       AtomMask[No] = true;
       status = true;
@@ -407,12 +413,12 @@
 void PrintAtomMask(bool *AtomMask, int AtomCount)
 {
-  Log() << Verbose(2) << "              ";
+  DoLog(2) && (Log() << Verbose(2) << "              ");
   for(int i=0;i<AtomCount;i++)
-    Log() << Verbose(0) << (i % 10);
-  Log() << Verbose(0) << endl;
-  Log() << Verbose(2) << "Atom mask is: ";
+    DoLog(0) && (Log() << Verbose(0) << (i % 10));
+  DoLog(0) && (Log() << Verbose(0) << endl);
+  DoLog(2) && (Log() << Verbose(2) << "Atom mask is: ");
   for(int i=0;i<AtomCount;i++)
-    Log() << Verbose(0) << (AtomMask[i] ? "t" : "f");
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (AtomMask[i] ? "t" : "f"));
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -441,5 +447,5 @@
     // transmorph graph keyset list into indexed KeySetList
     if (GlobalKeySetList == NULL) {
-      Log() << Verbose(1) << "ERROR: Given global key set list (graph) is NULL!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Given global key set list (graph) is NULL!" << endl);
       return false;
     }
@@ -449,5 +455,5 @@
     map<int, pair<double,int> > *AdaptiveCriteriaList = ScanAdaptiveFileIntoMap(path, *IndexKeySetList); // (Root No., (Value, Order)) !
     if (AdaptiveCriteriaList->empty()) {
-      eLog() << Verbose(0) << "Unable to parse file, incrementing all." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Unable to parse file, incrementing all." << endl);
       while (Walker->next != end) {
         Walker = Walker->next;
@@ -487,7 +493,7 @@
     if (!status) {
       if (Order == 0)
-        Log() << Verbose(1) << "Single stepping done." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Single stepping done." << endl);
       else
-        Log() << Verbose(1) << "Order at every site is already equal or above desired order " << Order << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Order at every site is already equal or above desired order " << Order << "." << endl);
     }
   }
@@ -506,5 +512,5 @@
 {
   if (SortIndex != NULL) {
-    Log() << Verbose(1) << "SortIndex is " << SortIndex << " and not NULL as expected." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "SortIndex is " << SortIndex << " and not NULL as expected." << endl);
     return false;
   }
@@ -557,9 +563,9 @@
   bool *AtomMask = NULL;
 
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
 #ifdef ADDHYDROGEN
-  Log() << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl);
 #else
-  Log() << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl);
 #endif
 
@@ -587,5 +593,5 @@
     // fill the bond structure of the individually stored subgraphs
   MolecularWalker->FillBondStructureFromReference(this, FragmentCounter, ListOfLocalAtoms, false);  // we want to keep the created ListOfLocalAtoms
-    Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     LocalBackEdgeStack = new StackClass<bond *> (MolecularWalker->Leaf->BondCount);
 //    // check the list of local atoms for debugging
@@ -596,9 +602,9 @@
 //      else
 //        Log() << Verbose(0) << "\t" << ListOfLocalAtoms[FragmentCounter][i]->Name;
-    Log() << Verbose(0) << "Gathering local back edges for subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Gathering local back edges for subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     MolecularWalker->Leaf->PickLocalBackEdges(ListOfLocalAtoms[FragmentCounter++], BackEdgeStack, LocalBackEdgeStack);
-    Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     MolecularWalker->Leaf->CyclicStructureAnalysis(LocalBackEdgeStack, MinimumRingSize);
-    Log() << Verbose(0) << "Done with Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Done with Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     delete(LocalBackEdgeStack);
   }
@@ -631,17 +637,17 @@
     while (MolecularWalker->next != NULL) {
       MolecularWalker = MolecularWalker->next;
-      Log() << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl);
       //MolecularWalker->Leaf->OutputListOfBonds(out);  // output atom::ListOfBonds for debugging
       if (MolecularWalker->Leaf->first->next != MolecularWalker->Leaf->last) {
         // call BOSSANOVA method
-        Log() << Verbose(0) << endl << " ========== BOND ENERGY of subgraph " << FragmentCounter << " ========================= " << endl;
+        DoLog(0) && (Log() << Verbose(0) << endl << " ========== BOND ENERGY of subgraph " << FragmentCounter << " ========================= " << endl);
         MolecularWalker->Leaf->FragmentBOSSANOVA(FragmentList[FragmentCounter], RootStack[FragmentCounter], MinimumRingSize);
       } else {
-        eLog() << Verbose(0) << "Subgraph " << MolecularWalker << " has no atoms!" << endl;
+        DoeLog(1) && (eLog()<< Verbose(1) << "Subgraph " << MolecularWalker << " has no atoms!" << endl);
       }
       FragmentCounter++;  // next fragment list
     }
   }
-  Log() << Verbose(2) << "CheckOrder is " << CheckOrder << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "CheckOrder is " << CheckOrder << "." << endl);
   delete[](RootStack);
   delete[](AtomMask);
@@ -674,9 +680,9 @@
   for(Graph::iterator runner = TotalGraph.begin(); runner != TotalGraph.end(); runner++) {
     KeySet test = (*runner).first;
-    Log() << Verbose(0) << "Fragment No." << (*runner).second.first << " with TEFactor " << (*runner).second.second << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Fragment No." << (*runner).second.first << " with TEFactor " << (*runner).second.second << "." << endl);
     BondFragments->insert(StoreFragmentFromKeySet(test, configuration));
     k++;
   }
-  Log() << Verbose(0) << k << "/" << BondFragments->ListOfMolecules.size() << " fragments generated from the keysets." << endl;
+  DoLog(0) && (Log() << Verbose(0) << k << "/" << BondFragments->ListOfMolecules.size() << " fragments generated from the keysets." << endl);
 
   // ===== 9. Save fragments' configuration and keyset files et al to disk ===
@@ -685,9 +691,9 @@
     CreateMappingLabelsToConfigSequence(SortIndex);
 
-    Log() << Verbose(1) << "Writing " << BondFragments->ListOfMolecules.size() << " possible bond fragmentation configs" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Writing " << BondFragments->ListOfMolecules.size() << " possible bond fragmentation configs" << endl);
     if (BondFragments->OutputConfigForListOfFragments(configuration, SortIndex))
-      Log() << Verbose(1) << "All configs written." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "All configs written." << endl);
     else
-      Log() << Verbose(1) << "Some config writing failed." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Some config writing failed." << endl);
 
     // store force index reference file
@@ -698,5 +704,9 @@
 
     // store Adjacency file
-    StoreAdjacencyToFile(configuration->configpath);
+    char *filename = Malloc<char> (MAXSTRINGSIZE, "molecule::FragmentMolecule - *filename");
+    strcpy(filename, FRAGMENTPREFIX);
+    strcat(filename, ADJACENCYFILE);
+    StoreAdjacencyToFile(configuration->configpath, filename);
+    Free(&filename);
 
     // store Hydrogen saturation correction file
@@ -710,12 +720,12 @@
 
     // free memory for bond part
-    Log() << Verbose(1) << "Freeing bond memory" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Freeing bond memory" << endl);
     delete(FragmentList); // remove bond molecule from memory
     Free(&SortIndex);
   } else {
-    Log() << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl);
   }
   delete(BondFragments);
-  Log() << Verbose(0) << "End of bond fragmentation." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of bond fragmentation." << endl);
 
   return ((int)(!FragmentationToDo)+1);    // 1 - continue, 2 - stop (no fragmentation occured)
@@ -736,12 +746,12 @@
   line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
   file.open(line.str().c_str());
-  Log() << Verbose(1) << "Writing OrderAtSite " << ORDERATSITEFILE << " ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Writing OrderAtSite " << ORDERATSITEFILE << " ... " << endl);
   if (file != NULL) {
     ActOnAllAtoms( &atom::OutputOrder, &file );
     file.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
     return true;
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     return false;
   }
@@ -764,5 +774,5 @@
   ifstream file;
 
-  Log() << Verbose(1) << "Begin of ParseOrderAtSiteFromFile" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of ParseOrderAtSiteFromFile" << endl);
   line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
   file.open(line.str().c_str());
@@ -785,8 +795,8 @@
     SetAtomValueToIndexedArray( MaxArray, &atom::nr, &atom::MaxOrder );
 
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
     status = true;
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     status = false;
   }
@@ -794,5 +804,5 @@
   Free(&MaxArray);
 
-  Log() << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl);
   return status;
 };
@@ -811,5 +821,5 @@
   int SP, Removal;
 
-  Log() << Verbose(2) << "Looking for removal candidate." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Looking for removal candidate." << endl);
   SP = -1; //0;  // not -1, so that Root is never removed
   Removal = -1;
@@ -838,6 +848,4 @@
 
   Leaf->BondDistance = mol->BondDistance;
-  for(int i=NDIM*2;i--;)
-    Leaf->cell_size[i] = mol->cell_size[i];
 
   // first create the minimal set of atoms from the KeySet
@@ -898,8 +906,8 @@
       }
     } else {
-      Log() << Verbose(0) << "ERROR: Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl);
     }
     if ((LonelyFlag) && (Leaf->AtomCount > 1)) {
-      Log() << Verbose(0) << *Runner << "has got bonds only to hydrogens!" << endl;
+      DoLog(0) && (Log() << Verbose(0) << *Runner << "has got bonds only to hydrogens!" << endl);
     }
 #ifdef ADDHYDROGEN
@@ -1048,8 +1056,8 @@
     TouchedList[j] = -1;
   }
-  Log() << Verbose(2) << "Remaining local nr.s on snake stack are: ";
+  DoLog(2) && (Log() << Verbose(2) << "Remaining local nr.s on snake stack are: ");
   for(KeySet::iterator runner = FragmentSet->begin(); runner != FragmentSet->end(); runner++)
-    Log() << Verbose(0) << (*runner) << " ";
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*runner) << " ");
+  DoLog(0) && (Log() << Verbose(0) << endl);
   TouchedIndex = 0; // set Index to 0 for list of atoms added on this level
 };
@@ -1128,10 +1136,10 @@
         Log() << Verbose(1+verbosity) << "Enough items on stack for a fragment!" << endl;
         // store fragment as a KeySet
-        Log() << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ";
+        DoLog(2) && (Log() << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ");
         for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
-          Log() << Verbose(0) << (*runner) << " ";
-        Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << (*runner) << " ");
+        DoLog(0) && (Log() << Verbose(0) << endl);
         //if (!CheckForConnectedSubgraph(FragmentSearch->FragmentSet))
-          //Log() << Verbose(0) << "ERROR: The found fragment is not a connected subgraph!" << endl;
+          //DoeLog(1) && (eLog()<< Verbose(1) << "The found fragment is not a connected subgraph!" << endl);
         InsertFragmentIntoGraph(FragmentSearch);
       }
@@ -1213,7 +1221,7 @@
 {
   bond *Binder = NULL;
-  Log() << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl);
   for(int i=Order;i--;) {
-    Log() << Verbose(1) << "Current SP level is " << i << ": ";
+    DoLog(1) && (Log() << Verbose(1) << "Current SP level is " << i << ": ");
     Binder = FragmentSearch.BondsPerSPList[2*i];
     while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
@@ -1226,5 +1234,5 @@
     cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
     // also start and end node
-    Log() << Verbose(0) << "cleaned." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "cleaned." << endl);
   }
 };
@@ -1256,12 +1264,12 @@
   int SP = -1;
 
-  Log() << Verbose(0) << "Starting BFS analysis ..." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Starting BFS analysis ..." << endl);
   for (SP = 0; SP < (Order-1); SP++) {
-    Log() << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)";
+    DoLog(1) && (Log() << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)");
     if (SP > 0) {
-      Log() << Verbose(0) << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
+      DoLog(0) && (Log() << Verbose(0) << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl);
       FragmentSearch.BondsPerSPCount[SP] = 0;
     } else
-      Log() << Verbose(0) << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "." << endl);
 
     RemainingWalkers = FragmentSearch.BondsPerSPCount[SP];
@@ -1273,8 +1281,8 @@
       Predecessor = CurrentEdge->leftatom;    // ... and leftatom is predecessor
       AtomKeyNr = Walker->nr;
-      Log() << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl);
       // check for new sp level
       // go through all its bonds
-      Log() << Verbose(1) << "Going through all bonds of Walker." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Going through all bonds of Walker." << endl);
       for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
         OtherWalker = (*Runner)->GetOtherAtom(Walker);
@@ -1284,19 +1292,19 @@
   #endif
                                                               ) {  // skip hydrogens and restrict to fragment
-          Log() << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *(*Runner) << "." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *(*Runner) << "." << endl);
           // set the label if not set (and push on root stack as well)
           if ((OtherWalker != Predecessor) && (OtherWalker->GetTrueFather()->nr > RootKeyNr)) { // only pass through those with label bigger than Root's
             FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
-            Log() << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
+            DoLog(3) && (Log() << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl);
             // add the bond in between to the SP list
             Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
             add(Binder, FragmentSearch.BondsPerSPList[2*(SP+1)+1]);
             FragmentSearch.BondsPerSPCount[SP+1]++;
-            Log() << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl;
+            DoLog(3) && (Log() << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl);
           } else {
             if (OtherWalker != Predecessor)
-              Log() << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl);
             else
-              Log() << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl);
           }
         } else Log() << Verbose(2) << "Is not in the restricted keyset or skipping hydrogen " << *OtherWalker << "." << endl;
@@ -1314,11 +1322,11 @@
 {
   bond *Binder = NULL;
-  Log() << Verbose(0) << "Printing all found lists." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Printing all found lists." << endl);
   for(int i=1;i<Order;i++) {    // skip the root edge in the printing
     Binder = FragmentSearch.BondsPerSPList[2*i];
-    Log() << Verbose(1) << "Current SP level is " << i << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Current SP level is " << i << "." << endl);
     while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
       Binder = Binder->next;
-      Log() << Verbose(2) << *Binder << endl;
+      DoLog(2) && (Log() << Verbose(2) << *Binder << endl);
     }
   }
@@ -1364,6 +1372,6 @@
   int Counter = FragmentSearch.FragmentCounter; // mark current value of counter
 
-  Log() << Verbose(0) << endl;
-  Log() << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
+  DoLog(0) && (Log() << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl);
 
   SetSPList(Order, FragmentSearch);
@@ -1377,10 +1385,10 @@
   // creating fragments with the found edge sets  (may be done in reverse order, faster)
   int SP = CountNumbersInBondsList(Order, FragmentSearch);
-  Log() << Verbose(0) << "Total number of edges is " << SP << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Total number of edges is " << SP << "." << endl);
   if (SP >= (Order-1)) {
     // start with root (push on fragment stack)
-    Log() << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl);
     FragmentSearch.FragmentSet->clear();
-    Log() << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Preparing subset for this root and calling generator." << endl);
 
     // prepare the subset and call the generator
@@ -1392,10 +1400,10 @@
     Free(&BondsList);
   } else {
-    Log() << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl);
   }
 
   // as FragmentSearch structure is used only once, we don't have to clean it anymore
   // remove root from stack
-  Log() << Verbose(0) << "Removing root again from stack." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Removing root again from stack." << endl);
   FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);
 
@@ -1404,5 +1412,5 @@
 
   // return list
-  Log() << Verbose(0) << "End of PowerSetGenerator." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of PowerSetGenerator." << endl);
   return (FragmentSearch.FragmentCounter - Counter);
 };
@@ -1450,5 +1458,5 @@
   atom *Walker = NULL;
 
-  Log() << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl);
   if (FragmentList == NULL) {
     FragmentList = new Graph;
@@ -1483,5 +1491,5 @@
 void FreeAllOrdersList(Graph ***FragmentLowerOrdersList, KeyStack &RootStack, molecule *mol)
 {
-  Log() << Verbose(1) << "Free'ing the lists of all orders per order." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Free'ing the lists of all orders per order." << endl);
   int RootNr = 0;
   int RootKeyNr = 0;
